<template>
  <div class="task-item-container">
        <div class="task-item">
            <div class="task-title">
                <input type="checkbox" @change="onChange($event)" :value="task.id">
                <span class="ml-10">{{task.title}}</span>
            </div>
            <div class="task-actions">
                <button class="btn btn-info" @click="toggleDetail">Detail</button>
                <button class="btn btn-danger ml-10" @click="deleteTask(task.id)">Remove</button>
            </div>
        </div>
        <div class="task-detail-form" v-if="showDetail">
            <TaskForm :editTask="task" @submit="editTaskFun"/>
        </div>
    </div>
</template>
<script lang="ts">
import { Component, Vue, Prop, Emit } from "vue-property-decorator";
import { mapState, mapActions } from "vuex"
import { namespace, Action } from 'vuex-class'
const TaskModule = namespace('TaskModule')

import TaskForm from './TaskForm.vue'
import { Task } from '@/models/task';
@Component({
  components: {
    TaskForm,
  }
})
export default class TaskList extends Vue {
  @Prop({required: true}) task: Task;
  showDetail = false;

  @Action('TaskModule/submitTask') submitTask: any;
  
  toggleDetail(){
    this.showDetail = !this.showDetail;
  }
  @Emit()
  deleteTask(id: number){
    return id;
  }
  editTaskFun(task: Task){
    this.submitTask(task);
    this.showDetail = !this.showDetail
  }
  onChange(event: any){
    this.$emit('bulkactions', {id: event.target.value, isSelected: event.target.checked});
  }
  
  getToday(){
    const today = new Date();
    const year = today.getFullYear();
    const month = ""+ (today.getMonth() + 1);
    const day = "" +today.getDate();
    return `${year}-${month.padStart(2,"0")}-${day.padStart(2, "0")}`;
  }
}
</script>
<style lang="scss">
.task-item-container{
    margin-bottom: 10px;
    &:first-of-type{
        margin-top: 10px;
    }
    .task-item{
        border: 1px solid black;
        padding: 10px;
        display: flex;
        justify-content: space-between;
        align-items: center;
    }
    .task-detail-form{
        border: 1px solid black;
        border-top: unset;
        padding: 10px;
    }

}
</style>